## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 27
%bcond check 1

Name:           rebuilderd
Version:        0.22.1
Release:        %autorelease
Summary:        - independent build verification daemon

SourceLicense:  GPL-3.0-or-later
License:        GPL-3.0-or-later
# LICENSE.dependencies contains a full license breakdown

URL:            https://github.com/kpcyrd/rebuilderd
Source:         %{url}/archive/refs/tags/v%{version}.tar.gz
Source:         rebuilderd.sysusers
Patch:          0001-worker-implement-custom-fedora-comparison.patch
Patch:          0001-tools-filter-other-architectures-in-a-repository.patch

Requires:       shared-mime-info
BuildRequires:  shared-mime-info
BuildRequires:  cargo-rpm-macros >= 24
BuildRequires:  systemd-rpm-macros
Recommends:     rebuilderd-tools

%global _description %{expand:
Rebuilderd - independent build verification daemon.}

%description %{_description}

%package worker
Summary:        - independent build verification worker

%description worker
Rebuilderd-worker - TODO

%package tools
Summary:        - independent build verification tools

%description tools
Rebuilderd-tools - TODO

%prep
%autosetup -n rebuilderd-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
mkdir -p %buildroot/%{_bindir}
cp target/rpm/rebuilderd-worker %buildroot/%{_bindir}
cp target/rpm/rebuilderd %buildroot/%{_bindir}
cp target/rpm/rebuildctl %buildroot/%{_bindir}

# TODO
#install -Dm 755 -t %buildroot/%{_libexecdir}/rebuilderd worker/rebuilder-*.sh

# systemd units
install -p -D -m 0644 contrib/systemd/rebuilderd.service %buildroot/%{_unitdir}/rebuilderd.service
install -p -D -m 0644 contrib/systemd/rebuilderd-sync@.service %buildroot/%{_unitdir}/rebuilderd-sync@.service
install -p -D -m 0644 contrib/systemd/rebuilderd-sync@.timer %buildroot/%{_unitdir}/rebuilderd-sync@.timer
install -p -D -m 0644 contrib/systemd/rebuilderd-worker@.service %buildroot/%{_unitdir}/rebuilderd-worker@.service

# tmpfiles
install -p -D -m 0644 contrib/systemd/rebuilderd.tmpfiles %{buildroot}%{_tmpfilesdir}/%{name}.conf

# sysusers
install -p -D -m 0644 %{SOURCE1} %{buildroot}%{_sysusersdir}/rebuilderd.conf

# config files
install -p -D -m 0600 contrib/confs/rebuilderd-worker.conf %{buildroot}%{_sysconfdir}/rebuilderd-worker.conf

%if %{with check}
%check
# compression tests fail somehow
#%cargo_test -- --workspace --exclude rebuildctl
%cargo_test
%endif

%files
#%license LICENSE
#%license LICENSE.dependencies
#%doc README.md
%{_bindir}/rebuilderd

%{_sysusersdir}/rebuilderd.conf
%{_tmpfilesdir}/%{name}.conf

%{_unitdir}/rebuilderd.service
%{_unitdir}/rebuilderd-sync@.service
%{_unitdir}/rebuilderd-sync@.timer


%files worker
%{_bindir}/rebuilderd-worker
%{_unitdir}/rebuilderd-worker@.service
%{_sysconfdir}/rebuilderd-worker.conf

%files tools
%{_bindir}/rebuildctl

%changelog
## START: Generated by rpmautospec
* Sat May 24 2025 John Doe <packager@example.com> - 0.22.1-1
- Uncommitted changes
## END: Generated by rpmautospec
